︠f3b3bd96-faa4-4e2a-aa36-93220abe5d6ds︠
#the example from the Conjecturing Project website
load('conjecturing.py')
def max_degree(g):
    return max(g.degree())
invariants = [Graph.size, Graph.order, max_degree]
objects = [graphs.CompleteGraph(n) for n in [3,4,5]]
conjecture(objects, invariants, 0)
︡50059d98-e461-4922-83e9-efd26d460b78︡{"stdout":"[size(x) <= 2*order(x), size(x) <= max_degree(x)^2 - 1, size(x) <= 1/2*max_degree(x)*order(x)]\n"}︡{"done":true}︡
︠dcf61daf-554a-4988-851e-1d27ac4d13bfs︠
#defining the complete graphs on 3,4,5, vertices
k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
︡f17bf583-910f-4e70-a482-ef9088c274f8︡{"done":true}︡
︠35f515a0-6443-45d7-89b1-6c52bd17868es︠
k3.show()
k4.show()
k5.show()
︡a1ddb674-5631-4f63-957c-9e18e8113cda︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/7553/tmp_ucarYt.svg","show":true,"text":null,"uuid":"ed601903-51c5-41f6-afad-be96dabcc2f1"},"once":false}︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/7553/tmp_pWAg8x.svg","show":true,"text":null,"uuid":"862fbc92-1dbe-4a90-8bdb-6c714dd47c53"},"once":false}︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/7553/tmp_RnTQHb.svg","show":true,"text":null,"uuid":"d11d6257-7100-4e06-89e0-79c1b1af7d38"},"once":false}︡{"done":true}︡
︠44514479-fb9d-4cdf-a250-6e103dfc9797s︠
#a new run, with named graphs, only 2 invariants, with size as the invariant that appears on the left
load('conjecturing.py')
def max_degree(g):
    return max(g.degree())
invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5]
conjecture(objects, invariants, invariants.index(Graph.size))
︡89fe93db-b8c8-4e7b-89f4-a5810c5e7c6e︡{"stdout":"[size(x) <= 2*order(x), size(x) <= (order(x) - 1)^2 - 1, size(x) <= floor(sinh(1/2*order(x) + 1/2))]"}︡{"stdout":"\n"}︡{"done":true}︡
︠a2a780cc-1b47-4fe4-93e7-b527d591f8c8︠
#found:
#Prop. If g is complete with order n, then size of g is n(n-1)/2
#CE = counterexample
#k6 is a CE to: size(x) <= 2*order(x)

︡a2be88b4-f7c0-44e8-b2a6-b6e8fb146ec0︡
︠70429ad2-20b7-419c-b909-0f8f70cb4f84s︠

load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6]
conjecture(objects, invariants, invariants.index(Graph.size))
︡4cd5c214-b70f-49d6-a635-933d4c5f6bf6︡{"stdout":"[size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= (order(x) - 1)^2 - 1, size(x) <= 2*order(x) + 3]\n"}︡{"done":true}︡
︠0f92b69d-b9b4-4389-b507-75e7873d3518s︠
#conjecture: size(x) <= 2*order(x) + 3, is false for a complete graph of order 7
#k7 is a CE
#add K7 and generate new conjectures
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6,k7]
conjecture(objects, invariants, invariants.index(Graph.size))
︡c69403a4-d7fe-49fd-9305-55952fda5764︡{"stdout":"[size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= (order(x) - 1)^2 - 1, size(x) <= floor(sinh(sqrt(2)*sqrt(order(x))))]"}︡{"stdout":"\n"}︡{"done":true}︡
︠7dd30324-2827-45b3-a90a-baad56ae5d80︠

#conjecture: size(x) <= 2*order(x) + 3, is false for a complete graph of order 7
#k7 is a CE
#add K7 and generate new conjectures
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())


k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6,k7]
conjecture(objects, invariants, invariants.index(Graph.size))
︡e82f3843-0b1c-4633-8bca-3ddfbee6d8cf︡{"stdout":"[size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= (order(x) - 1)^2 - 1, size(x) <= floor(sinh(sqrt(2)*sqrt(order(x))))]"}︡{"stdout":"\n"}︡{"done":true}︡
︠8b788a97-3172-40d1-a6c4-8705bc6f0017︠

#k2 is a CE to size(x) <= (order(x) - 1)^2 - 1
#claim: size(x) <= (order(x) - 1)^2 - 1 is true for connected graphs with order >= 3
#proved: size(x) <= (order(x) - 1)^2 is true for connected graphs

load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)
k2=graphs.CompleteGraph(2)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6,k7,k2]
conjecture(objects, invariants, invariants.index(Graph.size))
︡13ed6d5f-1f9d-4ba0-ba8e-27d18e897422︡{"stdout":"[size(x) <= (order(x) - 1)^2, size(x) <= floor(sinh(order(x) - 1)), size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= floor(sinh(sqrt(2)*sqrt(order(x))))]\n"}︡{"done":true}︡
︠2020d353-1311-4c88-be53-e323e16c37ecs︠
#lets add a new graph with the hope that we can get some non-sinh conjectures
#want path with order 3, p3
p3 = Graph(3)
p3.add_edge(0,1)
p3.add_edge(1,2)
︡d658fb80-ba63-4e0c-891b-f240a4ab502e︡{"done":true}︡
︠e35dc336-de8d-4cb0-9e07-bd5996356888s︠
p3.show()
︡d803547b-e71e-44f8-9899-fffdb93addbe︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/22579/tmp_0vZKl4.svg","show":true,"text":null,"uuid":"0e49ddbd-ad98-4125-aac6-e9b2ceae71bd"},"once":false}︡{"done":true}︡
︠01051756-a59c-4c3a-8ecd-7e7c8ca15f9ds︠
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)
k2=graphs.CompleteGraph(2)

#PATH ON 3 VERTICES
p3 = Graph(3)
p3.add_edge(0,1)
p3.add_edge(1,2)

#path on 4 vertices
p4 = Graph(4)
p4.add_edge(0,1)
p4.add_edge(1,2)
p4.add_edge(2,3)

#star with 3 rays, s3 (some graph theorists call this s4)
s3=Graph(4)
s3.add_edge(0,1)
s3.add_edge(0,2)
s3.add_edge(0,3)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6,k7,k2,p3,p4,s3]
conjecture(objects, invariants, invariants.index(Graph.size))
︡3d6db906-3b15-4213-a6fa-cbfbc61c356f︡{"stdout":"[size(x) <= (order(x) - 1)^2, size(x) <= floor(sinh(order(x) - 1)), size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= floor(sinh(sqrt(2)*sqrt(order(x))))]"}︡{"stdout":"\n"}︡{"done":true}︡
︠541e3082-4365-42fb-8982-b54d6bf69a96s︠
s=graphs.StarGraph(3)
s.show()
︡6bbf7a8c-70c5-4bb6-839d-71b8bcfe97ff︡{"file":{"filename":"/projects/de7f7a97-3fb3-40ae-af3c-aa8d25cee479/.sage/temp/compute8-us/22579/tmp_ju9zda.svg","show":true,"text":null,"uuid":"d3da2e1b-88d4-4e35-83ff-dbf76c26fe19"},"once":false}︡{"done":true}︡
︠83197dec-5e4a-415b-9d48-1eeeb04f7efds︠
#we've proved:
#for any graph with order n, size <= size of the complete graph with orner n = n(n-1)/2
#size of any graph order n <= (n-1)^2
#(stronger) for any graph with order n>2, size <= (n-1)^2-1
︡da3585e6-4d71-45b9-9310-cee2bee0606c︡{"done":true}︡
︠e9bb48c7-8682-49d9-a4e1-3bbf8c43dd96s︠
#lower bound conjectures
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)
k2=graphs.CompleteGraph(2)

#PATH ON 3 VERTICES
p3 = Graph(3)
p3.add_edge(0,1)
p3.add_edge(1,2)

#path on 4 vertices
p4 = Graph(4)
p4.add_edge(0,1)
p4.add_edge(1,2)
p4.add_edge(2,3)

#star with 3 rays, s3 (some graph theorists call this s4)
s3=Graph(4)
s3.add_edge(0,1)
s3.add_edge(0,2)
s3.add_edge(0,3)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5]
conjecture(objects, invariants, invariants.index(Graph.size),upperBound=False)
︡b3d61376-d5ab-4c4a-8e1f-f615873e5fc5︡{"stdout":"[size(x) >= order(x), size(x) >= 10^ceil(cos(order(x))), size(x) >= ceil(tan(log(order(x))))]\n"}︡{"done":true}︡
︠c22f76f4-c327-4547-9186-f292f29f3c10s︠
#lower bound conjectures
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)
k2=graphs.CompleteGraph(2)

#PATH ON 3 VERTICES
p3 = Graph(3)
p3.add_edge(0,1)
p3.add_edge(1,2)

#path on 4 vertices
p4 = Graph(4)
p4.add_edge(0,1)
p4.add_edge(1,2)
p4.add_edge(2,3)

#star with 3 rays, s3 (some graph theorists call this s4)
s3=Graph(4)
s3.add_edge(0,1)
s3.add_edge(0,2)
s3.add_edge(0,3)

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k2]
conjecture(objects, invariants, invariants.index(Graph.size),upperBound=False)
︡25d5d37d-a2e5-468c-a7b0-a2d98296e3fc︡{"stdout":"[size(x) >= order(x) - 1, size(x) >= 2*order(x) - 3, size(x) >= ceil(tan(log(order(x)))), size(x) >= 10^ceil(cos(order(x)))]\n"}︡{"done":true}︡
︠dcdc6fd2-2ebf-40f5-adba-ea749fefea27so︠
#NEW CONJECTURES for size, order, min degree, max degree
(1) SIZE <= 1/2(MAX_DEGREE)(ORDER)
(2) SIZE <=
︡8e6d5a63-f7e2-4418-9266-39a9a18da242︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 982, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"<string>\", line 1\n    (Integer(1)) SIZE <= Integer(1)/Integer(2)(MAX_DEGREE)(ORDER)\n                    ^\nSyntaxError: invalid syntax\n"}︡{"done":true}︡
︠51e38d39-3257-4679-bbdd-8abbffaace45s︠
#proved: size(x) <= (order(x) - 1)^2 is true for connected graphs
#add this fact as part of our "theory"


load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

#theorem1 is a graph invariant
theorem1 = lambda g: (g.order()-1)^2

k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
k6=graphs.CompleteGraph(6)
k7=graphs.CompleteGraph(7)
k2=graphs.CompleteGraph(2)

theorems = [theorem1]

invariants = [Graph.size, Graph.order]
objects = [k3,k4,k5,k6,k7,k2]
conjecture(objects, invariants, invariants.index(Graph.size),theory=theorems)
︡8a165842-fb13-4fc4-8ff2-4290ebd93c1a︡{"stdout":"[size(x) <= floor(sinh(order(x) - 1)), size(x) <= floor(sinh(1/2*order(x) + 1/2)), size(x) <= floor(sinh(sqrt(2)*sqrt(order(x))))]\n"}︡{"done":true}︡
︠731f8280-ba99-4408-b06f-5a777f562805s︠
theorem1(k3)
︡1c3c9f7f-9e20-4b98-9e7a-a708e2b38aa6︡{"stdout":"3\n"}︡{"done":true}︡
︠1c0e7c81-8644-401a-85df-79a96abea41as︠
theorem1(k4)
︡9f7b2184-8429-4482-9e09-918558a302e6︡{"stdout":"8\n"}︡{"done":true}︡
︠7bc09101-613a-41f9-a08e-d2375f332843s︠
theorem1(k2)
︡1337b6da-1a77-44be-87d1-3a5f55bb415a︡{"stdout":"0\n"}︡{"done":true}︡
︠4f20f560-f9db-4a53-9214-2e485f744d3cs︠
#claim: size >= 1/2(min_degree)(order)
#we'll add this to the "theory"
#lower bound conjectures
load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

def min_degree(g):
    return min(g.degree())


k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
p3 = graphs.PathGraph(3)

half_min_deg_times_order = lambda g: (1/2)*(min_degree(g))*g.order()
theory = [half_min_deg_times_order]

invariants = [Graph.size, Graph.order, max_degree, min_degree]
objects = [k3,k4,k5,p3]
conjecture(objects, invariants, invariants.index(Graph.size),upperBound=False,theory = theory)
︡f9f21d28-0e42-4be3-948b-a4698a6ca641︡{"stdout":"[size(x) >= max_degree(x), size(x) >= min_degree(x) + 1, size(x) >= (max_degree(x) - 1)^2 + 1, size(x) >= ceil(tan(log(order(x))))]\n"}︡{"done":true}︡
︠7516a7e0-b6bf-42e9-9cd1-af9c130aff2es︠
3+4
︡3159d77e-9064-4208-a04f-f484f36d396b︡{"stdout":"7\n"}︡{"done":true}︡
︠b2cdfafc-c271-446c-8b50-ca89d6775999s︠
#claim: size <= 1/2(max_degree)(order)
#we'll add this to the "theory"
#get new upper bound conjectures
#when the objects are k3,k4,k5 the theoretical upper bound is exactly the size
#either size = 1/2*max_degree*order for all connected graphs, or there's a graph where equality doesn't hold
#note: its not equality for p3, we'll add that

load('conjecturing.py')

def max_degree(g):
    return max(g.degree())

def min_degree(g):
    return min(g.degree())


k3=graphs.CompleteGraph(3)
k4=graphs.CompleteGraph(4)
k5=graphs.CompleteGraph(5)
p3 = graphs.PathGraph(3)

theorem1 = lambda g: (1/2)*(max_degree(g))*g.order()
theory = [theorem1]

invariants = [Graph.size, Graph.order, max_degree, min_degree]
objects = [k3,k4,k5,p3]
conjecture(objects, invariants, invariants.index(Graph.size),theory = theory)
︡47e73839-1664-42a2-9e00-2f7660360bb8︡{"stdout":"[size(x) <= 1/2*(min_degree(x) + 1)*max_degree(x), size(x) <= max_degree(x)^min_degree(x), size(x) <= (min_degree(x) + 1)^(max_degree(x) - 1)]\n"}︡{"done":true}︡
︠fbcf26bc-c842-441a-b115-ee33dba999a0s︠
#experiments for integers
load('conjecturing.py')

def distinct_prime_factors(n):
    return len(factor(n))

def total_number_of_factors(n):
    return (sum([factor(n)[i][1] for i in range(len(factor(n)))]))

def number_of_digits(n):
    return len(n.digits())
︡c2eeb0f5-eb42-4cbe-bea7-606bea9f90b7︡{"done":true}︡
︠ad4bcdd6-3cce-462f-8c02-7a51c23a158cs︠
distinct_prime_factors(6)
distinct_prime_factors(60)
︡cd0b2c37-219f-450e-85e5-7794ee5f40b1︡{"stdout":"2\n"}︡{"stdout":"3\n"}︡{"done":true}︡
︠db1a3147-6bc0-41fd-9371-9f6efb6729bas︠
total_number_of_factors(6)
total_number_of_factors(60)
︡c1daee57-5314-4b5f-ad54-ebdf5eaba2a5︡{"stdout":"2\n"}︡{"stdout":"4\n"}︡{"done":true}︡
︠cea9c3d3-80cb-46e0-b2bd-b6ba99093c38s︠
number_of_digits(6)
number_of_digits(60)
︡cf8bf096-705b-4872-afdd-14146a048c0b︡{"stdout":"1\n"}︡{"stdout":"2\n"}︡{"done":true}︡
︠b020bcd8-2752-487f-b0d5-f6ebf3639816s︠
#experiments for integers
load('conjecturing.py')

def distinct_prime_factors(n):
    return len(factor(n))

def total_number_of_factors(n):
    return (sum([factor(n)[i][1] for i in range(len(factor(n)))]))

def number_of_digits(n):
    return len(n.digits())

def number(n):
    return n

objects = [6,30,60,1000]
invariants = [distinct_prime_factors,total_number_of_factors,number_of_digits,number]

conjecture(objects,invariants,invariants.index(number))
︡4c6a13c1-5ad0-4aeb-9602-edbd2c57372d︡{"stdout":"[number(x) <= ceil(e^number_of_digits(x))^2 - total_number_of_factors(x), number(x) <= 10^(distinct_prime_factors(x) + 1), number(x) <= (number_of_digits(x) + 1)^total_number_of_factors(x) + distinct_prime_factors(x), number(x) <= 10^number_of_digits(x) - 2*distinct_prime_factors(x)]"}︡{"stdout":"\n"}︡{"done":true}︡
︠5bb909f2-73f4-4e80-b5a1-369ac66424d0s︠
#9 is a CE to the 4th conjecture
#add 9 to the objects, re-run
#experiments for integers
load('conjecturing.py')

def distinct_prime_factors(n):
    return len(factor(n))

def total_number_of_factors(n):
    return (sum([factor(n)[i][1] for i in range(len(factor(n)))]))

def number_of_digits(n):
    return len(n.digits())

def number(n):
    return n

objects = [6,30,60,1000,9]
invariants = [distinct_prime_factors,total_number_of_factors,number_of_digits,number]

conjecture(objects,invariants,invariants.index(number))
︡ba906642-ee3e-42d0-b475-db8ca634d146︡{"stdout":"[number(x) <= 10^number_of_digits(x) - 1, number(x) <= 10^(distinct_prime_factors(x) + 1), number(x) <= 10^floor(1/2*total_number_of_factors(x))*distinct_prime_factors(x), number(x) <= -distinct_prime_factors(x)^2 + 10^number_of_digits(x), number(x) <= floor((cosh(number_of_digits(x)) + total_number_of_factors(x))^2)]"}︡{"stdout":"\n"}︡{"done":true}︡
︠ab74a0c2-67c9-4ba9-8f47-366ec2db8987s︠
#101 is prime and a counterexample to the 2nd conjecture

load('conjecturing.py')

def distinct_prime_factors(n):
    return len(factor(n))

def total_number_of_factors(n):
    return (sum([factor(n)[i][1] for i in range(len(factor(n)))]))

def number_of_digits(n):
    return len(n.digits())

def number(n):
    return n

objects = [6,30,60,1000,9,101]
invariants = [distinct_prime_factors,total_number_of_factors,number_of_digits,number]

conjecture(objects,invariants,invariants.index(number))
︡56c1d537-50ad-4336-80d5-0125d74b3e3d︡{"stdout":"[number(x) <= 10^number_of_digits(x) - 1, number(x) <= 10^(distinct_prime_factors(x) + 1) + 1, number(x) <= -distinct_prime_factors(x)^2 + 10^number_of_digits(x), number(x) <= floor((cosh(number_of_digits(x)) + total_number_of_factors(x))^2), number(x) <= 10^(1/2*number_of_digits(x) + 1), number(x) <= e^(2*total_number_of_factors(x)/arccosh(distinct_prime_factors(x)))]"}︡{"stdout":"\n"}︡{"done":true}︡
︠c3383445-d70e-48a5-a5d6-ccf363fba743︠









